fix dzen.ru downloading since ~2024-04-10 by firk@cantconnect.ru

--- ./yt_dlp/extractor/yandexvideo.py.orig	2000-01-01 04:01:00.000000000 +0300
+++ ./yt_dlp/extractor/yandexvideo.py	2024-04-11 16:06:26.851189573 +0300
@@ -260,12 +260,14 @@
         data_json = self._search_json(
             r'("data"\s*:|data\s*=)', webpage, 'metadata', video_id, contains_pattern=r'{["\']_*serverState_*video.+}')
         serverstate = self._search_regex(r'(_+serverState_+video-site_[^_]+_+)',
-                                         webpage, 'server state').replace('State', 'Settings')
+                                         webpage, 'server state')
         uploader = self._search_regex(r'(<a\s*class=["\']card-channel-link[^"\']+["\'][^>]+>)',
                                       webpage, 'uploader', default='<a>')
         uploader_name = extract_attributes(uploader).get('aria-label')
-        video_json = try_get(data_json, lambda x: x[serverstate]['exportData']['video'], dict)
-        stream_urls = try_get(video_json, lambda x: x['video']['streams'])
+        openeditemid = try_get(data_json, lambda x: x[serverstate]['videoViewer']['openedItemId'])
+        video_json = try_get(data_json, lambda x: x[serverstate]['videoViewer']['items'][openeditemid], dict)
+        video2_json = try_get(video_json, lambda x: x['video'], dict)
+        stream_urls = try_get(video2_json, lambda x: x['streams'])
         formats, subtitles = [], {}
         for s_url in stream_urls:
             ext = determine_ext(s_url)
@@ -275,18 +277,19 @@
                 fmts, subs = self._extract_m3u8_formats_and_subtitles(s_url, video_id, 'mp4')
             formats.extend(fmts)
             subtitles = self._merge_subtitles(subtitles, subs)
-        return {
+        retval = {
             'id': video_id,
             'title': video_json.get('title') or self._og_search_title(webpage),
             'formats': formats,
             'subtitles': subtitles,
-            'duration': int_or_none(video_json.get('duration')),
-            'view_count': int_or_none(video_json.get('views')),
+            'duration': int_or_none(video2_json.get('duration')),
+            'view_count': int_or_none(video2_json.get('views')),
             'timestamp': int_or_none(video_json.get('publicationDate')),
             'uploader': uploader_name or data_json.get('authorName') or try_get(data_json, lambda x: x['publisher']['name']),
             'description': video_json.get('description') or self._og_search_description(webpage),
             'thumbnail': self._og_search_thumbnail(webpage) or try_get(data_json, lambda x: x['og']['imageUrl']),
         }
+        return retval
 
 
 class ZenYandexChannelIE(InfoExtractor):
